diff -uwrN sourceold/scripts/jmgUtility.cpp source/scripts/jmgUtility.cpp
--- sourceold/scripts/jmgUtility.cpp	2017-12-29 17:04:51.889600100 +1000
+++ source/scripts/jmgUtility.cpp	2018-11-11 08:30:08.535600000 +1000
@@ -106,6 +106,9 @@
 }
 void JMG_Utility_Change_Model_On_Timer::Created(GameObject *obj)
 {
+	if (Get_Float_Parameter("Time") == 0)
+		Timer_Expired(obj,1);
+	else
 	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),1);
 }
 void JMG_Utility_Change_Model_On_Timer::Timer_Expired(GameObject *obj,int number)
@@ -892,7 +895,7 @@
 			lastWanderPointSpot = Commands->Get_Position(obj);
 			Commands->Start_Timer(obj,this,0.1f,9);
 		}
-		else if (!(Get_Float_Parameter("MinRandWander") == Get_Float_Parameter("MaxRandWander") == 0))
+		else if (Get_Float_Parameter("MinRandWander") != 0.0f && Get_Float_Parameter("MaxRandWander") != 0.0f)
 			Commands->Start_Timer(obj,this,Get_Float_Parameter("MinRandWander") == Get_Float_Parameter("MaxRandWander") ? Get_Float_Parameter("MaxRandWander") : Commands->Get_Random(Get_Float_Parameter("MinRandWander"),Get_Float_Parameter("MaxRandWander")),2);
 	Commands->Start_Timer(obj,this,5.0,3);
 	Commands->Start_Timer(obj,this,0.1f,8);
@@ -995,7 +998,7 @@
 	if (number == 2)
 	{
 		Vector3 wanderPos = Vector3();
-		if (GetRandomPosition(&wanderPos) && (!Get_Int_Parameter("FollowTarget") || !currentAction.targetId))
+		if (GetRandomPosition(&wanderPos) && (!currentAction.targetId || (currentAction.targetId && !Get_Int_Parameter("FollowTarget"))))
 		{
 			moving = true;
 			lastWanderPointSpot = wanderPos;
@@ -1063,7 +1066,7 @@
 		if (attacking || currentAction.targetId)
 		{
 			GameObject *target = Commands->Find_Object(currentAction.targetId);
-			if ((attacking && !target) || (target && !Commands->Get_Health(target)))
+			if ((attacking && !target) || (target && !Commands->Get_Health(target)) || (target && Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(target) == Commands->Get_Player_Type(obj)))
 			{
 				lastSeenCount = 0;
 				attacking = false;
@@ -1086,7 +1089,7 @@
 	}
 	if (number == 9)
 	{
-		if (!Get_Int_Parameter("FollowTarget") || !currentAction.targetId)
+		if (!currentAction.targetId || (currentAction.targetId && !Get_Int_Parameter("FollowTarget")))
 		{
 			if (JmgUtility::SimpleDistance(Commands->Get_Position(obj),lastWanderPointSpot) <= grabNextPointDistance)
 			{
@@ -2236,7 +2239,7 @@
 			{
 				underwater = true;
 				isUnderwater[playerId] = true;
-				DestroySoundEmitter(&pantSoundId);
+				HideSoundEmitter(&pantSoundId);
 				if (startedFadeRed)
 				{
 					Set_Screen_Fade_Color_Player(obj,1.0f,0.0f,0.0f,JmgUtility::MathClamp(Get_Float_Parameter("DrownTime")-drownTime,0,Get_Float_Parameter("StarDrownSequence")));
@@ -2265,7 +2268,7 @@
 				isUnderwater[playerId] = false;
 				JMG_Utility_Set_Screen_Color_Fade_Controller::Update_Player(obj,0.1f);
 				Set_Fog_Range_Player(obj,JMG_Utility_Swimming_Zone::fogMinDistance,JMG_Utility_Swimming_Zone::fogMaxDistance,0.1f);
-				DestroySoundEmitter(&heartBeatSoundId);
+				HideSoundEmitter(&heartBeatSoundId);
 				if (drownTime > 1.0f)
 					CreateSoundEmitter(obj,Get_Parameter("PantingSoundEmitterModel"),&pantSoundId);
 				if (drownTime > Get_Float_Parameter("DrownTime"))
@@ -2279,7 +2282,7 @@
 				if (drownTime <= 0)
 				{
 					drownTime = 0.0f;
-					DestroySoundEmitter(&pantSoundId);
+					HideSoundEmitter(&pantSoundId);
 				}
 			}
 		}
@@ -2374,6 +2377,12 @@
 	}
 	Commands->Set_Model(soundEmitter,model);
 }
+void JMG_Utility_Swimming_Infantry::HideSoundEmitter(int *soundId)
+{
+	GameObject *soundEmitter = Commands->Find_Object(*soundId);
+	if (soundEmitter)
+		Commands->Set_Model(soundEmitter,"null");
+}
 void JMG_Utility_Swimming_Infantry::DestroySoundEmitter(int *soundId)
 {
 	GameObject *soundEmitter = Commands->Find_Object(*soundId);
@@ -2477,7 +2486,7 @@
 		if (EnemyID)
 		{
 			GameObject *Target = Commands->Find_Object(EnemyID);
-			if (!Target || !Commands->Get_Health(Target) || Commands->Get_Player_Type(Target) == Commands->Get_Player_Type(obj))
+			if (!Target || !Commands->Get_Health(Target) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(Target) == Commands->Get_Player_Type(obj)))
 			{
 				EnemyID = 0;
 				Goto_Location(obj);
@@ -2510,7 +2519,7 @@
 }
 void JMG_Utility_AI_Guardian_Aircraft::Damaged(GameObject *obj,GameObject *damager,float damage)
 {
-	if (damage <= 0 || (EnemyID && EnemyTimeOutTime) || Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj))
+	if (damage <= 0 || (EnemyID && EnemyTimeOutTime) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj)))
 		return;
 	EnemyID = Commands->Get_ID(damager);
 	EnemyTimeOutTime = 2;
@@ -2662,6 +2671,18 @@
 	huntingStarId = 0;
 	stuckTime = 0;
 	reverseTime = 0;
+	wanderingAiGroupId = Get_Int_Parameter("WanderingAIGroupID");
+	wanderSpeed = Get_Float_Parameter("WanderSpeed");
+	huntSpeed = Get_Float_Parameter("HuntSpeed");
+	attackSpeed = Get_Float_Parameter("AttackSpeed");
+	returnHomeSpeed = Get_Float_Parameter("ReturnHomeSpeed");
+	changeWanderGroupCustom = Get_Int_Parameter("ChangeWanderGroupCustom");
+	changeWanderSpeedCustom = Get_Int_Parameter("ChangeWanderSpeedCustom");
+	changeHuntDistanceCustom = Get_Int_Parameter("ChangeHuntDistanceCustom");
+	changeHuntSpeedCustom = Get_Int_Parameter("ChangeHuntSpeedCustom");
+	changeReturnHomeSpeedCustom = Get_Int_Parameter("ChangeReturnHomeSpeedCustom");
+	changeMaxSightFromHomeLocationCustom = Get_Int_Parameter("ChangeMaxSightFromHomeLocationCustom");
+	changeAttackSpeedCustom = Get_Int_Parameter("ChangeAttackSpeedCustom");
 	maxSightFromHomeLocation = Get_Float_Parameter("MaxSightRangeFromHome");
 	maxSightFromHomeLocation *= maxSightFromHomeLocation;
 	huntStealth = Get_Int_Parameter("HuntStealth") ? true : false;
@@ -2676,6 +2697,8 @@
 	}
 	attackArriveDistance = Get_Float_Parameter("AttackDistance") >= 0 ? Get_Float_Parameter("AttackDistance") : weaponEffectiveRange;
 	huntArriveDistance = Get_Float_Parameter("HuntArriveDistance");
+	wanderDistanceOverride = Get_Float_Parameter("WanderDistanceOverride");
+	wanderDistanceOverride *= wanderDistanceOverride;
 	Commands->Enable_Enemy_Seen(obj,true);
 	Commands->Start_Timer(obj,this,1.0f,1);
 	Commands->Start_Timer(obj,this,1.0f,2);
@@ -2709,7 +2732,7 @@
 		targetId = Commands->Get_ID(seen);
 		lastSeenTime = Commands->Get_Random_Int(30,60);
 		state = ATTACKING_TARGET;
-		Attack_Move(obj,seen,Vector3(),Get_Float_Parameter("AttackSpeed"),attackArriveDistance,true,false);
+		Attack_Move(obj,seen,Vector3(),attackSpeed,attackArriveDistance,true,false);
 	}
 	if (targetId == Commands->Get_ID(seen))
 		lastSeenTime = Commands->Get_Random_Int(30,60);
@@ -2724,25 +2747,26 @@
 			lastSeenTime--;
 			if (!lastSeenTime)
 			{
+				Return_Home(obj,ValidLastLocation(targetId));
 				targetId = 0;
-				Return_Home(obj);
 			}
 		}
 		if (targetId)
 		{
 			GameObject *target = Commands->Find_Object(targetId);
 			targetPos = Commands->Get_Position(target);
-			if (!target || !Commands->Get_Health(target) || Commands->Get_Player_Type(target) == -2 || (Commands->Get_Player_Type(obj) != -1 && Commands->Get_Player_Type(target) == Commands->Get_Player_Type(obj)))
+			if (!target || !Commands->Get_Health(target) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(target) == Commands->Get_Player_Type(obj)) || Is_Script_Attached(target,"JMG_Utility_AI_Goto_Player_Ignore_Object"))
 			{
+				lastSeenTime = 0;
+				Return_Home(obj,ValidLastLocation(targetId));
 				targetId = 0;
-				Return_Home(obj);
 			}
 		}
 		if (state == HUNTING_STAR)
 		{
 			GameObject *star = Get_GameObj(huntingStarId);
-			if (!star || !Commands->Get_Health(star))
-				Return_Home(obj);
+			if (!star || !Commands->Get_Health(star) || (huntSearchDistance >= 0.0f && JmgUtility::SimpleDistance(Commands->Get_Position(star),Commands->Get_Position(obj)) > huntSearchDistance) || Is_Script_Attached(star,"JMG_Utility_AI_Goto_Player_Ignore_Object"))
+				Return_Home(obj,false);
 		}
 		if (state == IDLE || state == RETURNING_HOME || state == WANDERING_GROUP)
 		{
@@ -2750,27 +2774,21 @@
 			if (star)
 			{
 				state = HUNTING_STAR;
-				Attack_Move(obj,star,Vector3(),Get_Float_Parameter("HuntSpeed"),huntArriveDistance,false,false);
+				Attack_Move(obj,star,Vector3(),huntSpeed,huntArriveDistance,false,false);
 			}
 		}
-		if (state == HUNTING_STAR)
-		{
-			GameObject *star = Get_GameObj(huntingStarId);
-			if (!star || (huntSearchDistance >= 0.0f && JmgUtility::SimpleDistance(Commands->Get_Position(star),Commands->Get_Position(obj)) > huntSearchDistance))
-				Return_Home(obj);
-		}
-		if (state == IDLE && Get_Int_Parameter("WanderingAIGroupID") != -1)
+		if (state == IDLE && wanderingAiGroupId != -1)
 		{
 			Vector3 wanderPos = Vector3();
 			if (GetRandomPosition(&wanderPos))
 			{
 				state = WANDERING_GROUP;
 				homeLocation = wanderPos;
-				Attack_Move(obj,NULL,wanderPos,Get_Float_Parameter("WanderSpeed"),1.0f,false,false);
+				Attack_Move(obj,NULL,wanderPos,wanderSpeed,1.0f,false,false);
 			}
 		}
 		if (state == RETURNING_HOME || state == WANDERING_GROUP)
-			if (JmgUtility::SimpleDistance(lastAction.location,Commands->Get_Position(obj)) <= (obj->As_VehicleGameObj() ? 25.0f : 1.0f))
+			if (JmgUtility::SimpleDistance(lastAction.location,Commands->Get_Position(obj)) <= (wanderDistanceOverride != 0 ? wanderDistanceOverride : (obj->As_VehicleGameObj() ? 25.0f : 1.0f)))
 				state = IDLE;
 		if (state == ACTION_BADPATH)
 			Cant_Get_To_target(obj);
@@ -2798,6 +2816,57 @@
 		huntArriveDistance += Commands->Get_Random(Get_Float_Parameter("RandomHuntArriveDistance"),Get_Float_Parameter("RandomHuntArriveDistance"));
 	}
 }
+void JMG_Utility_AI_Goto_Player::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (changeWanderGroupCustom != 0 && changeWanderGroupCustom == message)
+	{
+		wanderingAiGroupId = param;
+		if (state == WANDERING_GROUP)
+		{
+			Vector3 wanderPos = Vector3();
+			if (GetRandomPosition(&wanderPos))
+			{
+				homeLocation = wanderPos;
+				Attack_Move(obj,Commands->Find_Object(lastAction.targetId),homeLocation,lastAction.speed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+			}
+		}
+	}
+	if (changeWanderSpeedCustom != 0 && changeWanderSpeedCustom == message)
+	{
+		wanderSpeed = param/100.0f;
+		if (state == WANDERING_GROUP)
+			Attack_Move(obj,Commands->Find_Object(lastAction.targetId),lastAction.location,wanderSpeed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+	}
+	if (changeHuntDistanceCustom != 0 && changeHuntDistanceCustom == message)
+	{
+		huntSearchDistance = param/100.0f;
+		if (huntSearchDistance > 0)
+			huntSearchDistance *= huntSearchDistance;
+	}
+	if (changeHuntSpeedCustom != 0 && changeHuntSpeedCustom == message)
+	{
+		huntSpeed = param/100.0f;
+		if (state == HUNTING_STAR)
+			Attack_Move(obj,Commands->Find_Object(lastAction.targetId),lastAction.location,huntSpeed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+	}
+	if (changeReturnHomeSpeedCustom != 0 && changeReturnHomeSpeedCustom == message)
+	{
+		returnHomeSpeed = param/100.0f;
+		if (state == RETURNING_HOME)
+			Attack_Move(obj,Commands->Find_Object(lastAction.targetId),lastAction.location,returnHomeSpeed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+	}
+	if (changeMaxSightFromHomeLocationCustom != 0 && changeMaxSightFromHomeLocationCustom == message)
+	{
+		maxSightFromHomeLocation = param/100.0f;
+		maxSightFromHomeLocation *= maxSightFromHomeLocation;
+	}
+	if (changeAttackSpeedCustom != 0 && changeAttackSpeedCustom == message)
+	{
+		attackSpeed = param/100.0f;
+		if (state == ATTACKING_TARGET)
+			Attack_Move(obj,Commands->Find_Object(lastAction.targetId),lastAction.location,attackSpeed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+	}
+}
 void JMG_Utility_AI_Goto_Player::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason reason)
 {
 	if (reason == ACTION_COMPLETE_PATH_BAD_DEST)
@@ -2824,7 +2893,7 @@
 		targetId = Commands->Get_ID(damager);
 		lastSeenTime = Commands->Get_Random_Int(30,60);
 		state = ATTACKING_TARGET;
-		Attack_Move(obj,damager,Vector3(),Get_Float_Parameter("AttackSpeed"),attackArriveDistance,true,false);
+		Attack_Move(obj,damager,Vector3(),attackSpeed,attackArriveDistance,true,false);
 	}
 }
 void JMG_Utility_AI_Goto_Player::Attack_Move(GameObject *obj,GameObject *target,Vector3 location,float speed,float distance,bool attack,bool overrideLocation)
@@ -2861,7 +2930,7 @@
 {
 	GameObject *nearest = NULL;
 	float nearDist = -1.0f;
-	Vector3 pos = maxSightFromHomeLocation > 0 ? homeLocation : Commands->Get_Position(obj);
+	Vector3 pos = Commands->Get_Position(obj);
 	for (int x = 1;x < 128;x++)
 	{
 		GameObject *player = Get_GameObj(x);
@@ -2877,6 +2946,8 @@
 			else if (player->As_SmartGameObj() && player->As_SmartGameObj()->Is_Stealthed())
 				continue;
 		}
+		if (maxSightFromHomeLocation > 0 && JmgUtility::SimpleDistance(homeLocation,Commands->Get_Position(player)) > maxSightFromHomeLocation)
+			continue;
 		float tempDist = JmgUtility::SimpleDistance(pos,Commands->Get_Position(player));
 		if (huntSearchDistance >= 0.0f && tempDist > huntSearchDistance)
 			continue;
@@ -2889,18 +2960,23 @@
 	}
 	return nearest;
 }
-void JMG_Utility_AI_Goto_Player::Return_Home(GameObject *obj)
+void JMG_Utility_AI_Goto_Player::Return_Home(GameObject *obj,ValidLastLocation goNearLastWanderPoint)
 {
-	Vector3 wanderPos = Vector3();
-	if (Get_Int_Parameter("WanderingAIGroupID") != -1 && GetRandomPosition(&wanderPos))
+	Vector3 wanderPos;
+	if (goNearLastWanderPoint.valid && Commands->Get_Random(0.0f,1.0f) < Get_Float_Parameter("ChanceToInvestigateLastSeenLocation"))
 	{
 		state = WANDERING_GROUP;
-		Attack_Move(obj,NULL,wanderPos,Get_Float_Parameter("WanderSpeed"),1.0f,false,false);
+		Attack_Move(obj,NULL,goNearLastWanderPoint.location,wanderSpeed,1.0f,false,false);
+	}
+	else if (wanderingAiGroupId != -1 && GetRandomPosition(&wanderPos))
+	{
+		state = WANDERING_GROUP;
+		Attack_Move(obj,NULL,wanderPos,wanderSpeed,1.0f,false,false);
 	}
 	else if (Get_Int_Parameter("ReturnHome"))
 	{
 		state = RETURNING_HOME;
-		Attack_Move(obj,NULL,homeLocation,Get_Float_Parameter("ReturnHomeSpeed"),1.0f,false,false);
+		Attack_Move(obj,NULL,homeLocation,returnHomeSpeed,1.0f,false,false);
 	}
 	else
 	{
@@ -2954,17 +3030,17 @@
 	if (star)
 	{
 		state = HUNTING_STAR;
-		Attack_Move(obj,Commands->Find_Object(lastAction.targetId),Commands->Get_Position(star),Get_Float_Parameter("HuntSpeed"),huntArriveDistance,true,true);
+		Attack_Move(obj,Commands->Find_Object(lastAction.targetId),Commands->Get_Position(star),huntSpeed,huntArriveDistance,true,true);
 	}
-	else if (Get_Int_Parameter("WanderingAIGroupID") != -1 && GetRandomPosition(&wanderPos))
+	else if (wanderingAiGroupId != -1 && GetRandomPosition(&wanderPos))
 	{
 		state = WANDERING_GROUP;
-		Attack_Move(obj,Commands->Find_Object(lastAction.targetId),wanderPos,Get_Float_Parameter("WanderSpeed"),1.0f,true,true);
+		Attack_Move(obj,NULL,wanderPos,wanderSpeed,1.0f,true,true);
 	}
 	else
 	{
 		state = RETURNING_HOME;
-		Attack_Move(obj,Commands->Find_Object(lastAction.targetId),homeLocation,Get_Float_Parameter("ReturnHomeSpeed"),1.0f,true,true);
+		Attack_Move(obj,NULL,homeLocation,returnHomeSpeed,1.0f,true,true);
 	}
 }
 bool JMG_Utility_AI_Goto_Player::Choose_Target(GameObject *obj,GameObject *target)
@@ -2977,6 +3053,17 @@
 		return true;
 	return false;
 }
+JMG_Utility_AI_Goto_Player::ValidLastLocation::ValidLastLocation(int enemyId)
+{
+	GameObject *target = Commands->Find_Object(enemyId);
+	if (!target || !Commands->Get_Health(target))
+	{
+		this->valid = false;
+		return;
+	}
+	this->location = Commands->Get_Position(target);
+	this->valid = true;
+}
 AggressiveAttackSpotSystem *aggressiveAttackSpotSystemControl = NULL;
 void JMG_Utility_AI_Aggressive_Attack_Spot_Control::Created(GameObject *obj)
 {
@@ -3113,7 +3200,7 @@
 		{
 			GameObject *target = Commands->Find_Object(targetId);
 			targetPos = Commands->Get_Position(target);
-			if (!target || !Commands->Get_Health(target) || Commands->Get_Player_Type(target) == -2 || Commands->Get_Player_Type(target) == Commands->Get_Player_Type(obj))
+			if (!target || !Commands->Get_Health(target) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(target) == Commands->Get_Player_Type(obj)))
 			{
 				targetId = 0;
 				IdleChoice(obj,true);
@@ -3377,7 +3464,8 @@
 {
 	if (message == Get_Int_Parameter("TriggerCustom"))
 	{
-		Send_Custom_Event_To_Object(obj,Get_Parameter("Preset"),Get_Int_Parameter("Custom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+		int Param = Get_Int_Parameter("Param");
+		Send_Custom_Event_To_Object(obj,Get_Parameter("Preset"),Get_Int_Parameter("Custom"),Param == -1 ? param : Param,Get_Float_Parameter("Delay"));
 	}
 }
 void JMG_Utility_Basic_Spawner_Attach_Script::Created(GameObject *obj)
@@ -3959,7 +4047,7 @@
 		if (EnemyID)
 		{
 			GameObject *Target = Commands->Find_Object(EnemyID);
-			if (!Target || !Commands->Get_Health(Target) || Commands->Get_Player_Type(Target) == Commands->Get_Player_Type(obj))
+			if (!Target || !Commands->Get_Health(Target) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(Target) == Commands->Get_Player_Type(obj)))
 			{
 				EnemyID = 0;
 				Goto_Location(obj);
@@ -3992,7 +4080,7 @@
 }
 void JMG_Utility_AI_Guardian_Infantry::Damaged(GameObject *obj,GameObject *damager,float damage)
 {
-	if (damage <= 0 || (EnemyID && EnemyTimeOutTime) || Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj))
+	if (damage <= 0 || (EnemyID && EnemyTimeOutTime) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj)))
 		return;
 	EnemyID = Commands->Get_ID(damager);
 	EnemyTimeOutTime = Commands->Get_Random_Int(2,5);
@@ -4420,7 +4508,7 @@
 }
 void JMG_Utility_Zone_Teleport_To_Random_Wander_Point::Entered(GameObject *obj,GameObject *enter)
 {
-	if (CheckPlayerType(enter,playerType) || Commands->Get_Player_Type(enter) == -4)
+	if (CheckPlayerType(enter,playerType))
 		return;
 	Grab_Teleport_Spot(enter,5);
 }
@@ -4428,11 +4516,9 @@
 {
 	if (The_Game()->Get_Game_Duration_S() < 1.0f)
 	{
-		{
 			char params[220];
 			sprintf(params,"%d,%.2f",wanderPointGroup,safeTeleportDistance);
 			Commands->Attach_Script(enter,"JMG_Utility_Zone_Teleport_To_Random_Wander_Point_Attach",params);
-		}
 		return false;
 	}
 	if (!attempts)
@@ -4486,7 +4572,10 @@
 		Vector3 targetPos;
 		float facing;
 		if (!Get_A_Defense_Point(&targetPos,&facing))
+		{
+			Commands->Start_Timer(obj,this,0.25f,1);
 			return;
+		}
 		MoveablePhysClass *mphys = obj->As_PhysicalGameObj() ? obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
 		if (mphys && mphys->Find_Teleport_Location(targetPos,safeTeleportDistance,&targetPos))
 		{
@@ -5003,7 +5092,10 @@
 		int id = Get_Int_Parameter("ID");
 		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
 		if (object)
-			Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("SendCustom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+		{
+			int Param = Get_Int_Parameter("Param");
+			Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("SendCustom"),Param == -1 ? param : Param,Get_Float_Parameter("Delay"));
+		}
 	}
 }
 void JMG_Utility_Custom_Destroy_Self::Created(GameObject *obj)
@@ -5115,6 +5207,18 @@
 	huntStealth = Get_Int_Parameter("HuntStealth") ? true : false;
 	removeIgnoreTime = 0;
 	ignoreEnemyId = 0;
+	wanderingAiGroupId = Get_Int_Parameter("WanderingAIGroupID");
+	wanderSpeed = Get_Float_Parameter("WanderSpeed");
+	huntSpeed = Get_Float_Parameter("HuntSpeed");
+	attackSpeed = Get_Float_Parameter("AttackSpeed");
+	returnHomeSpeed = Get_Float_Parameter("ReturnHomeSpeed");
+	changeWanderGroupCustom = Get_Int_Parameter("ChangeWanderGroupCustom");
+	changeWanderSpeedCustom = Get_Int_Parameter("ChangeWanderSpeedCustom");
+	changeHuntDistanceCustom = Get_Int_Parameter("ChangeHuntDistanceCustom");
+	changeHuntSpeedCustom = Get_Int_Parameter("ChangeHuntSpeedCustom");
+	changeReturnHomeSpeedCustom = Get_Int_Parameter("ChangeReturnHomeSpeedCustom");
+	changeMaxSightFromHomeLocationCustom = Get_Int_Parameter("ChangeMaxSightFromHomeLocationCustom");
+	changeAttackSpeedCustom = Get_Int_Parameter("ChangeAttackSpeedCustom");
 	maxSightFromHomeLocation = Get_Float_Parameter("MaxSightRangeFromHome");
 	maxSightFromHomeLocation *= maxSightFromHomeLocation;
 	huntSearchDistance = Get_Float_Parameter("HuntSearchDistance") < 0.0f ? Get_Float_Parameter("HuntSearchDistance") : Get_Float_Parameter("HuntSearchDistance")*Get_Float_Parameter("HuntSearchDistance");
@@ -5126,6 +5230,8 @@
 	}
 	attackArriveDistance = Get_Float_Parameter("AttackDistance") >= 0 ? Get_Float_Parameter("AttackDistance") : weaponEffectiveRange;
 	huntArriveDistance = Get_Float_Parameter("HuntArriveDistance");
+	wanderDistanceOverride = Get_Float_Parameter("WanderDistanceOverride");
+	wanderDistanceOverride *= wanderDistanceOverride;
 	Commands->Enable_Enemy_Seen(obj,true);
 	Commands->Start_Timer(obj,this,1.0f,1);
 	Commands->Start_Timer(obj,this,1.0f,2);
@@ -5159,11 +5265,62 @@
 		targetId = Commands->Get_ID(seen);
 		lastSeenTime = Commands->Get_Random_Int(30,60);
 		state = ATTACKING_TARGET;
-		Attack_Move(obj,seen,Vector3(),Get_Float_Parameter("AttackSpeed"),attackArriveDistance,true,false);
+		Attack_Move(obj,seen,Vector3(),attackSpeed,attackArriveDistance,true,false);
 	}
 	if (targetId == Commands->Get_ID(seen))
 		lastSeenTime = Commands->Get_Random_Int(30,60);
 }
+void JMG_Utility_AI_Goto_Enemy::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (changeWanderGroupCustom != 0 && changeWanderGroupCustom == message)
+	{
+		wanderingAiGroupId = param;
+		if (state == WANDERING_GROUP)
+		{
+			Vector3 wanderPos = Vector3();
+			if (GetRandomPosition(&wanderPos))
+			{
+				homeLocation = wanderPos;
+				Attack_Move(obj,Commands->Find_Object(lastAction.targetId),homeLocation,lastAction.speed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+			}
+		}
+	}
+	if (changeWanderSpeedCustom != 0 && changeWanderSpeedCustom == message)
+	{
+		wanderSpeed = param/100.0f;
+		if (state == WANDERING_GROUP)
+			Attack_Move(obj,Commands->Find_Object(lastAction.targetId),lastAction.location,wanderSpeed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+	}
+	if (changeHuntDistanceCustom != 0 && changeHuntDistanceCustom == message)
+	{
+		huntSearchDistance = param/100.0f;
+		if (huntSearchDistance > 0)
+			huntSearchDistance *= huntSearchDistance;
+	}
+	if (changeHuntSpeedCustom != 0 && changeHuntSpeedCustom == message)
+	{
+		huntSpeed = param/100.0f;
+		if (state == HUNTING_STAR)
+			Attack_Move(obj,Commands->Find_Object(lastAction.targetId),lastAction.location,huntSpeed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+	}
+	if (changeReturnHomeSpeedCustom != 0 && changeReturnHomeSpeedCustom == message)
+	{
+		returnHomeSpeed = param/100.0f;
+		if (state == RETURNING_HOME)
+			Attack_Move(obj,Commands->Find_Object(lastAction.targetId),lastAction.location,returnHomeSpeed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+	}
+	if (changeMaxSightFromHomeLocationCustom != 0 && changeMaxSightFromHomeLocationCustom == message)
+	{
+		maxSightFromHomeLocation = param/100.0f;
+		maxSightFromHomeLocation *= maxSightFromHomeLocation;
+	}
+	if (changeAttackSpeedCustom != 0 && changeAttackSpeedCustom == message)
+	{
+		attackSpeed = param/100.0f;
+		if (state == ATTACKING_TARGET)
+			Attack_Move(obj,Commands->Find_Object(lastAction.targetId),lastAction.location,attackSpeed,lastAction.distance,lastAction.attack,lastAction.overrideLocation);
+	}
+}
 void JMG_Utility_AI_Goto_Enemy::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -5174,25 +5331,26 @@
 			lastSeenTime--;
 			if (!lastSeenTime)
 			{
+				Return_Home(obj,ValidLastLocation(targetId));
 				targetId = 0;
-				Return_Home(obj);
 			}
 		}
 		if (targetId)
 		{
 			GameObject *target = Commands->Find_Object(targetId);
 			targetPos = Commands->Get_Position(target);
-			if (!target || !Commands->Get_Health(target) || Commands->Get_Player_Type(target) == -2 || (Commands->Get_Player_Type(obj) != -1 && Commands->Get_Player_Type(target) == Commands->Get_Player_Type(obj)))
+			if (!target || !Commands->Get_Health(target) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(target) == Commands->Get_Player_Type(obj)) || Is_Script_Attached(target,"JMG_Utility_AI_Goto_Enemy_Ignore_Object"))
 			{
+				lastSeenTime = 0;
+				Return_Home(obj,ValidLastLocation(targetId));
 				targetId = 0;
-				Return_Home(obj);
 			}
 		}
 		if (state == HUNTING_STAR)
 		{
 			GameObject *star = Commands->Find_Object(huntingEnemyId);
-			if (!star || !Commands->Get_Health(star))
-				Return_Home(obj);
+			if (!star || !Commands->Get_Health(star) || (huntSearchDistance >= 0.0f && JmgUtility::SimpleDistance(Commands->Get_Position(star),Commands->Get_Position(obj)) > huntSearchDistance) || Is_Script_Attached(star,"JMG_Utility_AI_Goto_Enemy_Ignore_Object"))
+				Return_Home(obj,false);
 		}
 		if (state == IDLE || state == RETURNING_HOME || state == WANDERING_GROUP)
 		{
@@ -5200,27 +5358,21 @@
 			if (star)
 			{
 				state = HUNTING_STAR;
-				Attack_Move(obj,star,Vector3(),Get_Float_Parameter("HuntSpeed"),huntArriveDistance,false,false);
+				Attack_Move(obj,star,Vector3(),huntSpeed,huntArriveDistance,false,false);
 			}
 		}
-		if (state == HUNTING_STAR)
-		{
-			GameObject *star = Commands->Find_Object(huntingEnemyId);
-			if (!star || (huntSearchDistance >= 0.0f && JmgUtility::SimpleDistance(Commands->Get_Position(star),Commands->Get_Position(obj)) > huntSearchDistance))
-				Return_Home(obj);
-		}
-		if (state == IDLE && Get_Int_Parameter("WanderingAIGroupID") != -1)
+		if (state == IDLE && wanderingAiGroupId != -1)
 		{
 			Vector3 wanderPos = Vector3();
 			if (GetRandomPosition(&wanderPos))
 			{
 				state = WANDERING_GROUP;
 				homeLocation = wanderPos;
-				Attack_Move(obj,NULL,wanderPos,Get_Float_Parameter("WanderSpeed"),1.0f,false,false);
+				Attack_Move(obj,NULL,wanderPos,wanderSpeed,1.0f,false,false);
 			}
 		}
 		if (state == RETURNING_HOME || state == WANDERING_GROUP)
-			if (JmgUtility::SimpleDistance(lastAction.location,Commands->Get_Position(obj)) <= (obj->As_VehicleGameObj() ? 25.0f : 1.0f))
+			if (JmgUtility::SimpleDistance(lastAction.location,Commands->Get_Position(obj)) <= (wanderDistanceOverride != 0 ? wanderDistanceOverride : (obj->As_VehicleGameObj() ? 25.0f : 1.0f)))
 				state = IDLE;
 		if (state == ACTION_BADPATH)
 			Cant_Get_To_target(obj);
@@ -5276,7 +5428,7 @@
 		targetId = Commands->Get_ID(damager);
 		lastSeenTime = Commands->Get_Random_Int(30,60);
 		state = ATTACKING_TARGET;
-		Attack_Move(obj,damager,Vector3(),Get_Float_Parameter("AttackSpeed"),attackArriveDistance,true,false);
+		Attack_Move(obj,damager,Vector3(),attackSpeed,attackArriveDistance,true,false);
 	}
 }
 void JMG_Utility_AI_Goto_Enemy::Attack_Move(GameObject *obj,GameObject *target,Vector3 location,float speed,float distance,bool attack,bool overrideLocation)
@@ -5315,7 +5467,7 @@
 		return NULL;
 	GameObject *nearest = NULL;
 	float nearDist = -1.0f;
-	Vector3 pos = maxSightFromHomeLocation > 0 ? homeLocation : Commands->Get_Position(obj);
+	Vector3 pos = Commands->Get_Position(obj);
 	int myPlayerType = Commands->Get_Player_Type(obj);
 	for (SLNode<SmartGameObj> *current = GameObjManager::SmartGameObjList.Head();current;current = current->Next())
 	{
@@ -5338,6 +5490,8 @@
 			else if (o->As_SmartGameObj() && o->As_SmartGameObj()->Is_Stealthed())
 				continue;
 		}
+		if (maxSightFromHomeLocation > 0 && JmgUtility::SimpleDistance(homeLocation,Commands->Get_Position(o)) > maxSightFromHomeLocation)
+			continue;
 		float tempDist = JmgUtility::SimpleDistance(pos,Commands->Get_Position(o));
 		if (huntSearchDistance >= 0.0f && tempDist > huntSearchDistance)
 			continue;
@@ -5350,18 +5504,23 @@
 	}
 	return nearest;
 }
-void JMG_Utility_AI_Goto_Enemy::Return_Home(GameObject *obj)
+void JMG_Utility_AI_Goto_Enemy::Return_Home(GameObject *obj,ValidLastLocation goNearLastWanderPoint)
 {
-	Vector3 wanderPos = Vector3();
-	if (Get_Int_Parameter("WanderingAIGroupID") != -1 && GetRandomPosition(&wanderPos))
+	Vector3 wanderPos;
+	if (goNearLastWanderPoint.valid && Commands->Get_Random(0.0f,1.0f) < Get_Float_Parameter("ChanceToInvestigateLastSeenLocation"))
 	{
 		state = WANDERING_GROUP;
-		Attack_Move(obj,NULL,wanderPos,Get_Float_Parameter("WanderSpeed"),1.0f,false,false);
+		Attack_Move(obj,NULL,goNearLastWanderPoint.location,wanderSpeed,1.0f,false,false);
+	}
+	else if (wanderingAiGroupId != -1 && GetRandomPosition(&wanderPos))
+	{
+		state = WANDERING_GROUP;
+		Attack_Move(obj,NULL,wanderPos,wanderSpeed,1.0f,false,false);
 	}
 	else if (Get_Int_Parameter("ReturnHome"))
 	{
 		state = RETURNING_HOME;
-		Attack_Move(obj,NULL,homeLocation,Get_Float_Parameter("ReturnHomeSpeed"),1.0f,false,false);
+		Attack_Move(obj,NULL,homeLocation,returnHomeSpeed,1.0f,false,false);
 	}
 	else
 	{
@@ -5415,17 +5574,17 @@
 	if (star && Commands->Get_ID(star) != ignoreEnemyId)
 	{
 		state = HUNTING_STAR;
-		Attack_Move(obj,Commands->Find_Object(lastAction.targetId),Commands->Get_Position(star),Get_Float_Parameter("HuntSpeed"),huntArriveDistance,true,true);
+		Attack_Move(obj,Commands->Find_Object(lastAction.targetId),Commands->Get_Position(star),huntSpeed,huntArriveDistance,true,true);
 	}
-	else if (Get_Int_Parameter("WanderingAIGroupID") != -1 && GetRandomPosition(&wanderPos))
+	else if (wanderingAiGroupId != -1 && GetRandomPosition(&wanderPos))
 	{
 		state = WANDERING_GROUP;
-		Attack_Move(obj,Commands->Find_Object(lastAction.targetId),wanderPos,Get_Float_Parameter("WanderSpeed"),1.0f,true,true);
+		Attack_Move(obj,NULL,wanderPos,wanderSpeed,1.0f,true,true);
 	}
 	else
 	{
 		state = RETURNING_HOME;
-		Attack_Move(obj,Commands->Find_Object(lastAction.targetId),homeLocation,Get_Float_Parameter("ReturnHomeSpeed"),1.0f,true,true);
+		Attack_Move(obj,NULL,homeLocation,returnHomeSpeed,1.0f,true,true);
 	}
 }
 bool JMG_Utility_AI_Goto_Enemy::Choose_Target(GameObject *obj,GameObject *target)
@@ -5438,6 +5597,17 @@
 		return true;
 	return false;
 }
+JMG_Utility_AI_Goto_Enemy::ValidLastLocation::ValidLastLocation(int enemyId)
+{
+	GameObject *target = Commands->Find_Object(enemyId);
+	if (!target || !Commands->Get_Health(target))
+	{
+		this->valid = false;
+		return;
+	}
+	this->location = Commands->Get_Position(target);
+	this->valid = true;
+}
 void JMG_Utility_AI_Goto_Enemy_Not_Star::Created(GameObject *obj)
 {
 	state = IDLE;
